diff --git a/libavfilter/vf_fade.c b/libavfilter/vf_fade.c
index e4ba1b4..9def9ba 100644
--- a/libavfilter/vf_fade.c
+++ b/libavfilter/vf_fade.c
@@ -1,4 +1,5 @@
 /*
+ * Copyright (c) 2011 Mark Himsley
  * Copyright (c) 2010 Brandon Mintern
  * Copyright (c) 2007 Bobby Bingham
  *
@@ -27,44 +28,81 @@
 
 #include "libavutil/pixdesc.h"
 #include "avfilter.h"
+#include "drawutils.h"
+#include "internal.h"
+
+/* #define DEBUG */
 
 typedef struct {
     int factor, fade_per_frame;
     unsigned int frame_index, start_frame, stop_frame;
     int hsub, vsub, bpp;
+    unsigned int black_level, black_level_scaled;
+    uint8_t is_packed_rgb;
+    uint8_t rgba_map[4];
+    int alpha;
+
+    char type_expr[256], alpha_expr[256];
 } FadeContext;
 
+enum { RED = 0, GREEN, BLUE, ALPHA };
+enum { Y = 0, U, V };
+
 static av_cold int init(AVFilterContext *ctx, const char *args, void *opaque)
 {
     FadeContext *fade = ctx->priv;
     unsigned int nb_frames;
-    char in_out[4];
+    int nb_args = 0;
 
-    if (!args ||
-        sscanf(args, " %3[^:]:%u:%u", in_out, &fade->start_frame, &nb_frames) != 3) {
-        av_log(ctx, AV_LOG_ERROR,
-               "Expected 3 arguments '(in|out):#:#':'%s'\n", args);
-        return AVERROR(EINVAL);
+#ifdef DEBUG
+    av_log(ctx, AV_LOG_DEBUG, "init()\n");
+#endif
+
+    if (!args) {
+        goto end_args;
+    }
+
+#ifdef DEBUG
+    av_log(ctx, AV_LOG_DEBUG, "init() args:%s\n", args);
+#endif
+
+    if ((nb_args = sscanf(args, " %3[^:]:%u:%u:%255[^:]", fade->type_expr, &fade->start_frame, &nb_frames, fade->alpha_expr)) < 3) {
+        goto end_args;
+    }
+
+    if(strstr(fade->alpha_expr,"alpha=1")) {
+#ifdef DEBUG
+        av_log(ctx, AV_LOG_DEBUG, "init() alpha\n");
+#endif
+        fade->alpha = 1;
     }
 
     nb_frames = nb_frames ? nb_frames : 1;
     fade->fade_per_frame = (1 << 16) / nb_frames;
-    if (!strcmp(in_out, "in"))
+
+    if (!strcmp(fade->type_expr, "in"))
         fade->factor = 0;
-    else if (!strcmp(in_out, "out")) {
+    else if (!strcmp(fade->type_expr, "out")) {
         fade->fade_per_frame = -fade->fade_per_frame;
         fade->factor = (1 << 16);
     } else {
         av_log(ctx, AV_LOG_ERROR,
-               "first argument must be 'in' or 'out':'%s'\n", in_out);
+               "first argument must be 'in' or 'out':'%s'\n", fade->type_expr);
         return AVERROR(EINVAL);
     }
+
     fade->stop_frame = fade->start_frame + nb_frames;
 
     av_log(ctx, AV_LOG_INFO,
-           "type:%s start_frame:%d nb_frames:%d\n",
-           in_out, fade->start_frame, nb_frames);
+           "type:%s start_frame:%d nb_frames:%d alpha:%d\n",
+           fade->type_expr, fade->start_frame, nb_frames, fade->alpha);
+
     return 0;
+
+end_args:
+    av_log(ctx, AV_LOG_ERROR,
+           "Decoded %d arguments but expected at least 3 arguments '(in|out):#:#[alpha=1]'%s'\n", nb_args, args ? args : "<none>");
+    return AVERROR(EINVAL);
 }
 
 static int query_formats(AVFilterContext *ctx)
@@ -74,7 +112,10 @@ static int query_formats(AVFilterContext *ctx)
         PIX_FMT_YUV411P,  PIX_FMT_YUV410P,
         PIX_FMT_YUVJ444P, PIX_FMT_YUVJ422P, PIX_FMT_YUVJ420P,
         PIX_FMT_YUV440P,  PIX_FMT_YUVJ440P,
+        PIX_FMT_YUVA420P,
         PIX_FMT_RGB24,    PIX_FMT_BGR24,
+        PIX_FMT_ARGB,     PIX_FMT_ABGR,
+        PIX_FMT_RGBA,     PIX_FMT_BGRA,
         PIX_FMT_NONE
     };
 
@@ -82,7 +123,21 @@ static int query_formats(AVFilterContext *ctx)
     return 0;
 }
 
-static int config_props(AVFilterLink *inlink)
+const static enum PixelFormat studio_level_pix_fmts[] = {
+    PIX_FMT_YUV444P,  PIX_FMT_YUV422P,  PIX_FMT_YUV420P,
+    PIX_FMT_YUV411P,  PIX_FMT_YUV410P,
+    PIX_FMT_YUV440P,
+    PIX_FMT_NONE
+};
+
+static enum PixelFormat alpha_pix_fmts[] = {
+    PIX_FMT_YUVA420P,
+    PIX_FMT_ARGB, PIX_FMT_ABGR,
+    PIX_FMT_RGBA, PIX_FMT_BGRA,
+    PIX_FMT_NONE
+};
+
+static int config_input(AVFilterLink *inlink)
 {
     FadeContext *fade = inlink->dst->priv;
     const AVPixFmtDescriptor *pixdesc = &av_pix_fmt_descriptors[inlink->format];
@@ -91,9 +146,37 @@ static int config_props(AVFilterLink *inlink)
     fade->vsub = pixdesc->log2_chroma_h;
 
     fade->bpp = av_get_bits_per_pixel(pixdesc) >> 3;
+    fade->alpha = fade->alpha ? ff_fmt_is_in(inlink->format, alpha_pix_fmts) : 0;
+    fade->is_packed_rgb = ff_fill_rgba_map(fade->rgba_map, inlink->format) >= 0;
+
+    /* use CCIR601/709 black level for studio-level pixel non-alpha components */
+    fade->black_level =
+            ff_fmt_is_in(inlink->format, studio_level_pix_fmts) && !fade->alpha ? 16 : 0;
+    /* 32768 = 1 << 15, it is an integer representation
+     * of 0.5 and is for rounding. */
+    fade->black_level_scaled = (fade->black_level << 16) + 32768;
     return 0;
 }
 
+static void fade_plane(int y, int h, int w,
+                       int fade_factor, int black_level, int black_level_scaled,
+                       uint8_t offset, uint8_t step, int bytes_per_plane,
+                       uint8_t *data, int line_size)
+{
+    uint8_t *p;
+    int i, j;
+
+    /* luma, alpha or rgb plane */
+    for (i = 0; i < h; i++) {
+        p = data + offset + (y+i) * line_size;
+        for (j = 0; j < w * bytes_per_plane; j++) {
+            /* fade->factor is using 16 lower-order bits for decimal places. */
+            *p = ((*p - black_level) * fade_factor + black_level_scaled) >> 16;
+            p+=step;
+        }
+    }
+}
+
 static void draw_slice(AVFilterLink *inlink, int y, int h, int slice_dir)
 {
     FadeContext *fade = inlink->dst->priv;
@@ -102,29 +185,33 @@ static void draw_slice(AVFilterLink *inlink, int y, int h, int slice_dir)
     int i, j, plane;
 
     if (fade->factor < UINT16_MAX) {
-        /* luma or rgb plane */
-        for (i = 0; i < h; i++) {
-            p = outpic->data[0] + (y+i) * outpic->linesize[0];
-            for (j = 0; j < inlink->w * fade->bpp; j++) {
-                /* fade->factor is using 16 lower-order bits for decimal
-                 * places. 32768 = 1 << 15, it is an integer representation
-                 * of 0.5 and is for rounding. */
-                *p = (*p * fade->factor + 32768) >> 16;
-                p++;
-            }
-        }
-
-        if (outpic->data[1] && outpic->data[2]) {
-            /* chroma planes */
-            for (plane = 1; plane < 3; plane++) {
-                for (i = 0; i < h; i++) {
-                    p = outpic->data[plane] + ((y+i) >> fade->vsub) * outpic->linesize[plane];
-                    for (j = 0; j < inlink->w >> fade->hsub; j++) {
-                        /* 8421367 = ((128 << 1) + 1) << 15. It is an integer
-                         * representation of 128.5. The .5 is for rounding
-                         * purposes. */
-                        *p = ((*p - 128) * fade->factor + 8421367) >> 16;
-                        p++;
+        if (fade->alpha) {
+            // alpha only
+            plane = fade->is_packed_rgb ? 0 : ALPHA; // alpha is on plane 0 for packed formats
+                                                     // or plane 3 for planar formats
+            fade_plane(y, h, inlink->w,
+                       fade->factor, fade->black_level, fade->black_level_scaled,
+                       fade->is_packed_rgb ? fade->rgba_map[ALPHA] : 0, // alpha offset for packed formats
+                       fade->is_packed_rgb ? 4 : 1,                 // pixstep for 8 bit packed formats
+                       1, outpic->data[plane], outpic->linesize[plane]);
+        } else {
+            /* luma or rgb plane */
+            fade_plane(y, h, inlink->w,
+                       fade->factor, fade->black_level, fade->black_level_scaled,
+                       0, 1, // offset & pixstep for Y plane or RGB packed format
+                       fade->bpp, outpic->data[0], outpic->linesize[0]);
+            if (outpic->data[1] && outpic->data[2]) {
+                /* chroma planes */
+                for (plane = 1; plane < 3; plane++) {
+                    for (i = 0; i < h; i++) {
+                        p = outpic->data[plane] + ((y+i) >> fade->vsub) * outpic->linesize[plane];
+                        for (j = 0; j < inlink->w >> fade->hsub; j++) {
+                            /* 8421367 = ((128 << 1) + 1) << 15. It is an integer
+                             * representation of 128.5. The .5 is for rounding
+                             * purposes. */
+                            *p = ((*p - 128) * fade->factor + 8421367) >> 16;
+                            p++;
+                        }
                     }
                 }
             }
@@ -156,7 +243,7 @@ AVFilter avfilter_vf_fade = {
 
     .inputs    = (AVFilterPad[]) {{ .name            = "default",
                                     .type            = AVMEDIA_TYPE_VIDEO,
-                                    .config_props    = config_props,
+                                    .config_props    = config_input,
                                     .get_video_buffer = avfilter_null_get_video_buffer,
                                     .start_frame      = avfilter_null_start_frame,
                                     .draw_slice      = draw_slice,